<html>
<head>
<title>Log</title>
<style>
* {font-family:monospace;}
body {font-size:12px;}
h1 {font-size:14px;margin:0;padding:4px;}
a {color:#0000FF;text-decoration:none;}
a:hover {text-decoration:underline;}
/*a:visited {color:#660055;}*/
textarea {width:95%;height:96px;font-size:12px;}
</style>
</head>
<body><?php
$out = "";
if(!empty($_GET['log'])) {
  $fpath = "./".reset(explode("_", $_GET['log'], 2))."/".$_GET['log'];
  if(preg_match("/d:\\\apache\\\www\\\pokemon\\\egts\\\pokemondpds\\\logs\\\(.*?)\.log$/i", realpath($fpath)) && file_exists($fpath)) {
    $out .= "<a href=\"./log.php\">Back to the log index...</a><br/><br/>";
    $arr = unserialize(file_get_contents($fpath));
    $i = 0;
    foreach($arr as $k=>$v) {
      $i++;
      // string
      $out .= "<h1>{$k} (string)</h1><textarea>";
      if(is_array($v)) {
        foreach($v as $k2=>$v2) {
          $out .= "[$k2] => {$v2}\n";
        }
      } else $out .= $v;
      $out .= "</textarea>";
      // binary
      if($i == 2 || $i == 3 || $i == 4) {
        $out .= "<h1>{$k} (raw/hex)</h1><textarea>";
        if(is_array($v)) {
          foreach($v as $k2=>$v2) {
            $out .= "[$k2] => ".strToHex($v2)."\n";
          }
        } else $out .= strToHex($v);
        $out .= "</textarea>";
      }
    }
  } else $out .= "Could not find log.";
  
} else {
  $dir = opendir(".");
  while(($file = readdir($dir)) !== false) {
    if(is_dir($file) && strlen($file) > 8) {
      $logdir = opendir("./{$file}/");
      $logs = array();
      while(($logfile = readdir($logdir)) !== false) {
        $logfileinfo = pathinfo($logfile);
        if($logfileinfo['extension'] == "log") {
          #$logs[filemtime()] = $logfile;
          if(preg_match("/(.*?)(.*?)\.asp_(.*?) (.*?)\.log/", $logfile, $match)) {
            $stamp = $match[4]."-".str_replace("0.", "", $match[3]);
            $logs[$stamp] = $logfile;
          }
        }
      }
      closedir($logdir);
      ksort($logs, SORT_NUMERIC);
      $out .= "<ul><li>[DD.MM.YYYY@HH:MM:SS]</li>";
      foreach($logs as $k=>$v) {
        $exp = explode("-", $k, 2);
        $exp = reset($exp);
        $out .= "<li>[".date("d.m.Y@H:i:s", $exp)."] <a href=\"./log.php?log={$v}\">{$v}</a></li>";
      }
      $out .= "</ul>";
    }
  }
  closedir($dir);
}

echo empty($out) ? "No logs has yet been... logged." : $out;
?>
</body>
</html>
<?php
function strToHex($string) {
  $hex="";
  for ($i=0; $i < strlen($string); $i++) {
    $hex .= dechex(ord($string[$i]));
  }
  return $hex;
}
?>